/*this sketch is based on the sketch shared by @jhoepffner on the isadora user forum in june 2015
http://troikatronix.com/troikatronixforum/discussion/2054/osc-from-isadora-to-arduino#latest
and has been adapted to be used with a ws2812b led strip by andrew martyn sugars.  the re-shared patch works with 
2 leds 
*/

// this bit does the library inclusion part of the sketch
#include <SPI.h>
#include <Ethernet.h>
#include <ArdOSC.h>
#include <FastLED.h>


//sets up the ethernet shield to listen for incoming osc messages
byte myMac[] = { 
  0xDE, 0xAD, 0xBE, 0xEF, 0xFE, 0xED }; //N°MAC de l'Arduino
byte myIp[]  = { 192, 168, 0, 21 }; //N° IP de l'Arduino
int  serverPort  = 8000; //port de l'Arduino


// some led set up stuff
// How many leds in your strip?
#define NUM_LEDS 5
// For led chips like Neopixels, which have a data line, ground, and power, you just
// need to define DATA_PIN.  For led chipsets that are SPI based (four wires - data, clock,
// ground, and power), like the LPD8806 define both DATA_PIN and CLOCK_PIN
#define DATA_PIN 2
// Define the array of leds
CRGB leds[NUM_LEDS];

//this bit looks like setting the osc bit
OSCServer server; 

void setup(){  
  Serial.begin(9600);
  Ethernet.begin(myMac ,myIp); 
  server.begin(serverPort);
  
  //set callback function ie osc addresses to listen to
    server.addCallback("/led01",&func1);
    server.addCallback("/led02",&func2);
    
  
   //define led type ie tells arduino which led strip being used
   FastLED.addLeds<NEOPIXEL, DATA_PIN>(leds, NUM_LEDS);
}

void loop(){
  if(server.aviableCheck()>0){

  }
}


void func1(OSCMessage *_mes){
  byte t01 = _mes->getArgInt32(0); //first value of the osc message
  byte t02 = _mes->getArgInt32(1);
  byte t03 = _mes->getArgInt32(2);
   leds[0] = CRGB((t01),(t02),(t03));  //this bit sets the value of rgb on led strip based on values from first osc message
  FastLED.show();  // this line is vital otherwise the leds do not light up
  delay(30);
  
}

//a copy and paste of above with numbers increased for second led
void func2(OSCMessage *_mes){
  byte t03 = _mes->getArgInt32(0);
  byte t04 = _mes->getArgInt32(1);
  byte t05 = _mes->getArgInt32(2);
  
   leds[1] = CRGB((t03),(t04),(t05));
  FastLED.show();
  delay(30);
  
}

